#!/usr/bin/python3


# Version 0.5
# Date update: 09.10.2024
# Email: aleksandr.egai@red-soft.ru
# (c) RED SOFT


import sys
sys.path.insert(0, '/usr/share/smbpass/')
import ui_smbpass  # pyuic5 -x ui_smbpass.ui -o ui_smbpass.py
import subprocess
import os
from PyQt5.QtWidgets import *
from PyQt5 import QtWidgets, QtCore


# Проверка ПК на членство в домене
def realm_check():
    result_check = os.popen("realm list | grep server-software | head -1 | awk '{ print $NF }'")
    result_check = ', '.join(result_check)
    result_check = result_check.replace("\n", "")
    if result_check == 'active-directory':
        result_check = 1
    else:
        result_check = 0
    return result_check

def check_kpasswd():
    # Проверяем, существует ли утилита kpasswd по пути
    kpasswd_path = "/usr/bin/kpasswd"
    if not os.path.exists(kpasswd_path):
        # Проверяем, установлен ли пакет krb5-workstation 
        QMessageBox.about(None, "Ошибка!", "Утилита /usr/bin/kpasswd не найдена, установите пекет krb5-workstation.")
        sys.exit(1)

# Функция изменения пароля доменного пользователя
def change(old_pass, new_pass, user_name):
    get_ip = """
        #!/usr/bin/bash
        result_domain="$(realm list | grep domain-name | head -1 | awk '{ print $NF;exit;}')"
        adcli info $result_domain | grep "domain-controller ="| awk '{print $3}'
    """
    get_dc = subprocess.Popen(get_ip, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
    dc = get_dc.communicate()
    dc = dc[0].decode('utf-8')
    command = f"echo -e '{old_pass}\n{new_pass}\n{new_pass}' |  /usr/bin/kpasswd"
    process = subprocess.Popen(command, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
    output, error = process.communicate()
    return output, error, dc

def get_users():
    result_check = os.popen("whoami")
    result_check = ', '.join(result_check)
    result_check = result_check.replace("\n", "")
    return result_check


class SmbpasswdApp(QtWidgets.QMainWindow, ui_smbpass.Ui_MainWindow):
    def __init__(self):
        super().__init__()
        self.setupUi(self)  # Инициализация дизайна
        self.setWindowFlags(
            QtCore.Qt.Window |
            QtCore.Qt.CustomizeWindowHint |
            QtCore.Qt.WindowTitleHint |
            QtCore.Qt.WindowCloseButtonHint |
            QtCore.Qt.WindowStaysOnTopHint |
            QtCore.Qt.WindowMinimizeButtonHint
        )
        self.checkBox.stateChanged.connect(self.state_changed)
        self.Button_Save.clicked.connect(self.button_save)
        self.lineEdit_4.setText(get_users())
        self.lineEdit_4.setDisabled(True)

    def state_changed(self):
        if self.checkBox.isChecked():
            self.lineEdit_1.setEchoMode(QtWidgets.QLineEdit.Normal)
            self.lineEdit_2.setEchoMode(QtWidgets.QLineEdit.Normal)
            self.lineEdit_3.setEchoMode(QtWidgets.QLineEdit.Normal)
        else:
            self.lineEdit_1.setEchoMode(QtWidgets.QLineEdit.Password)
            self.lineEdit_2.setEchoMode(QtWidgets.QLineEdit.Password)
            self.lineEdit_3.setEchoMode(QtWidgets.QLineEdit.Password)

    def button_save(self):
        realm_check()
        old_pass = self.lineEdit_1.text()
        new_pass = self.lineEdit_2.text()
        new_pass_repeat = self.lineEdit_3.text()
        user_name = self.lineEdit_4.text()

        if new_pass != new_pass_repeat:
            QMessageBox.about(self, "Изменение пароля", "   Пароли не совпадают!       ")
        elif new_pass == "" or new_pass == "":
            QMessageBox.about(self, "Изменение пароля", "   Введите новый пароль!       ")
        elif old_pass == "":
            QMessageBox.about(self, "Изменение пароля", "   Введите ваш пароль!       ")
        elif user_name == "":
            QMessageBox.about(self, "Изменение пароля", "   Введите имя пользователя!       ")
        else:
            self.Button_Save.setEnabled(False)
            self.Button_Exit.setEnabled(False)
            self.label_status.setText("Ожидайте ...")
            QApplication.processEvents()  # Позволяет Qt обрабатывать события приложения
            out, err, dc = change(old_pass, new_pass, user_name)  # Получаем значения функции
            print("Результат: ", out.decode('utf-8'))
            print("Ошибка: ", err.decode('utf-8'))
            if err.decode('utf-8') == "":
                QMessageBox.about(self, "Изменение пароля", "  Пароль успешно изменен!      ")
            elif 'kpasswd: Preauthentication failed getting initial ticket' in err.decode('utf-8'):
                QMessageBox.critical(self, "Ошибка изменения пароля", 'Не удалось выполнить предварительную аутентификацию при получении первоначального запроса.')
            elif 'NT_STATUS_LOGON_FAILURE' in err.decode('utf-8'):
                s_err_pass = "Проверьте введённый пароль и имя пользователя!"
                err_replace = err.decode('utf-8').replace("Could not connect to machine", "Не удалось подключиться к машине")
                QMessageBox.critical(self, "Ошибка изменения пароля", s_err_pass + "\n" + err_replace)
            elif 'NT_STATUS_INVALID_ADDRESS' in err.decode('utf-8'):
                err_replace = err.decode('utf-8').replace("Unable to connect to SMB server on machine connection. Error was :", " Не удалось подключиться к контроллеру домена.\n Проверьте сетевые настройки.\n")
                QMessageBox.critical(self, "Ошибка изменения пароля", err_replace)
            elif 'password might not meet length criteria' in err.decode('utf-8'):
                QMessageBox.critical(self, "Ошибка изменения пароля", "Компьютер " + dc + "отклонил изменение пароля.\nНарушение правила обновления пароля.\nНапример, пароль может не соответствовать критериям безопасности.")
            elif err.decode('utf-8') != "":
                QMessageBox.critical(self, "Ошибка изменения пароля", err.decode('utf-8'))

            self.lineEdit_1.clear()
            self.lineEdit_2.clear()
            self.lineEdit_3.clear()
            self.label_status.setText("")
            self.Button_Save.setEnabled(True)
            self.Button_Exit.setEnabled(True)


def main():
    app = QtWidgets.QApplication(sys.argv)
    check_kpasswd()
    if realm_check() == 0:
        print("Компьютер не в домене!")
        QMessageBox.critical(QWidget(), "Изменение пароля", "Компьютер не в домене Windows/SAMBA!")
    else:
        window = SmbpasswdApp()
        window.show()
        app.exec_()


if __name__ == '__main__':
        main()
